using System;
using System.Runtime.InteropServices;
using System.Collections.Generic;
using System.Text;
using System.Resources;
using System.Reflection;
using System.IO;

namespace grdlic
{
    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public unsafe struct CustomerInfoRaw
    {
        public fixed byte firstName[64];
        public fixed byte lastName[64];
        public fixed byte email[128];
        public fixed byte companyName[128];
        public fixed byte phone[32];
    }

    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public unsafe struct GrdVendorCodes
    {
        public UInt32 m_publicCode;
        public UInt32 m_privateReadCode;
        public UInt32 m_privateWriteCode;

        public GrdVendorCodes(UInt32 publicCode, UInt32 privateReadCode = 0, UInt32 privateWriteCode = 0)
        {
            this.m_publicCode = publicCode;
            this.m_privateReadCode = privateReadCode;
            this.m_privateWriteCode = privateWriteCode;
        }
    }

    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public unsafe struct GrdAesContextInternal
    {
        public fixed byte iv[16];   // initialization vector
        public fixed byte inf[8];   // additional encryption info
    }

    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public unsafe struct GrdProductFeaturePairInternal
    {
        public UInt32 m_productNumber;
        public UInt32 m_featureNumber;

        public GrdProductFeaturePairInternal(UInt32 productNumber, UInt32 featureNumber)
        {
            this.m_productNumber = productNumber;
            this.m_featureNumber = featureNumber;
        }
    }
}
