package grdlic;

/** Operation status codes */
public class GrdStatus
{
    /** Successful operation status */
    public static final GrdStatus OK = new GrdStatus(0);
    /** Invalid handle */
    public static final GrdStatus INVALID_HANDLE = new GrdStatus(1);
    /** Feature not found */
    public static final GrdStatus FEATURE_NOT_FOUND = new GrdStatus(2);
    /** Feature network resource exhausted */
    public static final GrdStatus FEATURE_RESOURCE_EXHAUST = new GrdStatus(3);
    /** Invalid feature data */
    public static final GrdStatus INVALID_FEATURE = new GrdStatus(4);
    /** Serial number is invalid */
    public static final GrdStatus INVALID_SERIAL_NUMBER = new GrdStatus(5);
    /** Can't read DL license file because of hardware mismatched or part of file header is corrupted */
    public static final GrdStatus INVALID_LICENSE = new GrdStatus(6);
    /** License with this licenseId has not been activated yet or reactivation required */
    public static final GrdStatus LICENSE_NOT_ACTIVATED = new GrdStatus(7);
    /** License already activated */
    public static final GrdStatus LICENSE_ALREADY_ACTIVATED = new GrdStatus(8);
    /** Can not get hardware id */
    public static final GrdStatus GET_HARDWARE_ID_ERROR = new GrdStatus(9);
    /** Insufficient number of computer components to activate */
    public static final GrdStatus NOT_ENOUGH_HARWARE_TO_BIND = new GrdStatus(10);
    /** Unable to send request */
    public static final GrdStatus REQUEST_FAILED = new GrdStatus(12);
    /** Unable to receive response */
    public static final GrdStatus GET_RESPONSE_FAILED = new GrdStatus(13);
    /** Unable to find server */
    public static final GrdStatus SERVER_NOT_FOUND = new GrdStatus(14);
    /** Incorrect response format or data not valid */
    public static final GrdStatus INCORRECT_RESPONSE_DATA = new GrdStatus(15);
    /** Error during creation of file (e.g. license file) */
    public static final GrdStatus FILE_CREATION_ERROR = new GrdStatus(16);
    /** Serial number resource exhausted */
    public static final GrdStatus SERIAL_NUMBER_RESOURCE_EXHAUSTED = new GrdStatus(17);
    /** No updates available for license */
    public static final GrdStatus NO_UPDATES_AVAILABLE = new GrdStatus(18);
    /** Activation not enabled by software vendor reasons */
    public static final GrdStatus ACTIVATION_NOT_AVAILABLE = new GrdStatus(19);
    /** No customer info specified */
    public static final GrdStatus NO_CUSTOMER_SPECIFIED = new GrdStatus(20);
    /** Can't activate non demo license */
    public static final GrdStatus CAN_NOT_ACTIVATE_NON_DEMO_LICENSE = new GrdStatus(21);
    /** API version too low */
    public static final GrdStatus OUTDATED_API_VERSION = new GrdStatus(22);
    /** Invalid function argument */
    public static final GrdStatus INVALID_PARAMETER = new GrdStatus(23);
    /** Buffer is not enough to perform operation */
    public static final GrdStatus BUFFER_TOO_SMALL = new GrdStatus(24);
    /** Internal error */
    public static final GrdStatus INTERNAL_ERROR = new GrdStatus(25);
    /** Software vendor has banned serial number and license */
    public static final GrdStatus LICENSE_IS_BANNED = new GrdStatus(26);
    /** No license available (e.g. order access time is over) */
    public static final GrdStatus NO_LICENSE_AVAILABLE = new GrdStatus(27);
    /** Feature execution counter is exhausted */
    public static final GrdStatus FEATURE_RUNCOUNTER_EXHAUST = new GrdStatus(28);
    /** Feature life time is expired */
    public static final GrdStatus FEATURE_EXPIRED = new GrdStatus(29);
    /** Invalid public key */
    public static final GrdStatus INVALID_PUBLIC_KEY = new GrdStatus(30);
    /** Service is not supported */
    public static final GrdStatus NO_SERVICE = new GrdStatus(31);
    /** Admin runtime is not installed or outdated */
    public static final GrdStatus UNABLE_SEND_REQUEST_TO_ADMIN_RUNTIME = new GrdStatus(32);
    /** Guardant dongle not found */
    public static final GrdStatus DONGLE_NOT_FOUND = new GrdStatus(33);
    /** No any results found */
    public static final GrdStatus NO_RESULTS_FOUND = new GrdStatus(34);
    /** Invalid message or digest */
    public static final GrdStatus INVALID_DIGEST = new GrdStatus(35);
    /** The period of using feature has not yet arrived or the feature is not active */
    public static final GrdStatus FEATURE_INACTIVE = new GrdStatus(36);
    /** Access to memory beyond its range */
    public static final GrdStatus MEMORY_OUT_OF_RANGE = new GrdStatus(37);
    /** Access denied */
    public static final GrdStatus ACCESS_DENIED = new GrdStatus(38);
    /** The number of password attempts has been exhausted */
    public static final GrdStatus NUMBER_ATTEMPTS_EXHAUSTED = new GrdStatus(39);
    /** Such serial number not found on server */
    public static final GrdStatus SERIAL_NUMBER_NOT_FOUND = new GrdStatus(40);
    /** Invalid memory ID specified or item does not exist */
    public static final GrdStatus INVALID_MEMORY = new GrdStatus(41);
    /** Running in virtual environment detected */
    public static final GrdStatus VIRTUAL_ENVIRONMENT_DETECTED = new GrdStatus(42);
    /** Detected running in remote desktop mode */
    public static final GrdStatus REMOTE_DESKTOP_DETECTED = new GrdStatus(43);
    /** Outdated Gurdant Control Center version */
    public static final GrdStatus OUTDATED_GCC_VERSION = new GrdStatus(44);
    /** Rehost is not allowed */
    public static final GrdStatus REHOST_IS_NOT_ALLOWED = new GrdStatus(45);
    /** DL storage corrupted */
    public static final GrdStatus STORAGE_CORRUPTED = new GrdStatus(46);
    /** DL storage ID mismatch (input is not intended for current storage) */
    public static final GrdStatus STORAGE_ID_MISMATCH = new GrdStatus(47);
    /** Invalid update for DL received or update has been installed before */
    public static final GrdStatus INVALID_UPDATE_OR_ALREADY_INSTALLED = new GrdStatus(48);
    /** Invalid rehost data sent to server */
    public static final GrdStatus INVALID_REHOST_DATA = new GrdStatus(49);
    /** Hardware id mismatch */
    public static final GrdStatus HARDWARE_ID_MISMATCH = new GrdStatus(50);
    /** Reactivation is not allowed because of license contains write memory or features with counter */
    public static final GrdStatus REACTIVATION_IS_NOT_ALLOWED = new GrdStatus(51);
    /** Recipient has the same license activated as the license trying to rehost to it */
    public static final GrdStatus RECIPIENT_HAS_THE_SAME_LICENSE = new GrdStatus(52);
    /** Detach failed for some of chosen features */
    public static final GrdStatus GRD_CAN_NOT_DETACH_SOME_FEATURES = new GrdStatus(53);
    /** Required cancel previous detach before making new one */
    public static final GrdStatus GRD_CANCEL_PREVIOUS_DETACH_REQUIRED = new GrdStatus(54);
    /** Detached license already exprired */
    public static final GrdStatus GRD_DETACHED_LICENSE_EXPIRED = new GrdStatus(55);
    /** Detached license not found */
    public static final GrdStatus GRD_DETACHED_LICENSE_NOT_FOUND = new GrdStatus(56);
    /** Detach forbidden by Gurdant Control Center */
    public static final GrdStatus GRD_DETACH_FORBIDDEN_BY_GCC = new GrdStatus(57);
    /** Trial license expired */
    public static final GrdStatus GRD_TRIAL_LICENSE_EXPIRED = new GrdStatus(58);
    /** Operation is not allowed */
    public static final GrdStatus GRD_OPERATION_IS_NOT_ALLOWED = new GrdStatus(59);
    /** Timer error */
    public static final GrdStatus GRD_RTC_ERROR = new GrdStatus(60);

    /** Dynamic library not found */
    public static final GrdStatus LIBRARY_NOT_FOUND = new GrdStatus(371);

    public int mValue;

    GrdStatus()
    {
        mValue = 0;
    }

    public GrdStatus(int value)
    {
        mValue = value;
    }

    public int getValue()
    {
        return mValue;
    }


    static GrdStatus fromValue(int _value)
    {
        return new GrdStatus(_value);
    }

    public boolean equals(Object obj)
    {
        if (this == obj)
        return true;
        if ((obj == null) || (obj.getClass() != this.getClass()))
        return false;

        GrdStatus h = (GrdStatus)obj;
        return mValue == h.mValue;
    }
}
