unit fruExample;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, fruBaseFrame, Vcl.StdCtrls, Vcl.ExtCtrls, uHelper, grdlic_delphi;

type
  Tfrm_Example = class(TBaseFrame)
    pnl_Top: TPanel;
    grp_RemoteMode: TGroupBox;
    cb_LocalMode: TCheckBox;
    cb_RemoteMode: TCheckBox;
    grp_Codes: TGroupBox;
    lbl_Public: TLabel;
    lbl_Read: TLabel;
    lbl_Write: TLabel;
    edt_Public: TEdit;
    edt_Read: TEdit;
    edt_Write: TEdit;
    grp_Visibility: TGroupBox;
    lbl_FeatureId: TLabel;
    lbl_LicenseId: TLabel;
    lbl_ProductId: TLabel;
    edt_FeatureId: TEdit;
    edt_LicenseId: TEdit;
    edt_ProductId: TEdit;
    btn_GrdFeatureLogin: TButton;
    edt_HostName: TEdit;
    lbl_HostHame: TLabel;
    btn_GrdFeatureLogout: TButton;
    btn_GrdGetApiVersion: TButton;
    edt_MajorVersion: TEdit;
    edt_MinorVersion: TEdit;
    btn_GrdMemoryGetSize: TButton;
    btn_GrdMemoryRead: TButton;
    btn_GrdMemoryWrite: TButton;
    edt_Handle: TEdit;
    lbl_MemId: TLabel;
    edt_MemId: TEdit;
    edt_ReadData: TEdit;
    edt_WriteData: TEdit;
    edt_MemSize: TEdit;
    lbl_MemSize: TLabel;
    grp_Algo: TGroupBox;
    btn_GrdFeatureEncrypt: TButton;
    lbl_FeatureCheckResult: TLabel;
    edt_EncDecBuffer: TEdit;
    edt_EncBuffer: TEdit;
    edt_Buffer: TEdit;
    btn_GrdVerifyDigest: TButton;
    btn_GrdFeatureSign: TButton;
    btn_GrdFeatureDecrypt: TButton;
    btn_GrdFeatureCheck: TButton;
    grp_Memory: TGroupBox;
    lbl_ReadPass: TLabel;
    edt_ReadPass: TEdit;
    edt_WritePass: TEdit;
    grp_Service: TGroupBox;
    btn_GrdFeatureGetRunCounter: TButton;
    btn_GrdFeatureGetMaxConcurrentResource: TButton;
    btn_GrdFeatureGetTimeLimit: TButton;
    btn_GrdGetRealTime: TButton;
    btn_GrdGetLicenseInfo: TButton;
    btn_GrdLedBlink: TButton;
    lbl_WritePass: TLabel;
    lbl_EncData: TLabel;
    lbl_DataSize: TLabel;
    edt_DataSize: TEdit;
    lbl_Offset: TLabel;
    edt_Offset: TEdit;
    edt_RunCounterData: TEdit;
    edt_MaxConcRes: TEdit;
    edt_TimeLimit: TEdit;
    edt_DongleTime: TEdit;
    procedure btn_GrdFeatureCheckClick(Sender: TObject);
    procedure btn_GrdFeatureDecryptClick(Sender: TObject);
    procedure btn_GrdFeatureEncryptClick(Sender: TObject);
    procedure btn_GrdFeatureGetMaxConcurrentResourceClick(Sender: TObject);
    procedure btn_GrdFeatureGetRunCounterClick(Sender: TObject);
    procedure btn_GrdFeatureGetTimeLimitClick(Sender: TObject);
    procedure btn_GrdGetApiVersionClick(Sender: TObject);
    procedure btn_GrdGetLicenseInfoClick(Sender: TObject);
    procedure btn_GrdFeatureLoginClick(Sender: TObject);
    procedure btn_GrdFeatureLogoutClick(Sender: TObject);
    procedure btn_GrdFeatureSignClick(Sender: TObject);
    procedure btn_GrdGetRealTimeClick(Sender: TObject);
    procedure btn_GrdLedBlinkClick(Sender: TObject);
    procedure btn_GrdMemoryGetSizeClick(Sender: TObject);
    procedure btn_GrdMemoryReadClick(Sender: TObject);
    procedure btn_GrdMemoryWriteClick(Sender: TObject);
    procedure btn_GrdVerifyDigestClick(Sender: TObject);
  private
    { Private declarations }
    FVisibility: TVisibility;
    FCodes: TVendorCodes;
    FFeature: TFeatureObject;
    FLastError: Integer;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

var
  frm_Example: Tfrm_Example;

  EncDecBuf: array [0..15] of Byte;
  ResBuffer: array [0..15] of Byte;
  SignBuf: array [0..19] of Byte;
  SignResult: array [0..39] of Byte;
const
  PubKey: array[0..39] of Byte = ($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
                                  $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
                                  $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
                                  $00,$00,$00,$00,$00,$00,$00,$00,$00,$00);
  Buffer: array[0..31] of Byte = ($12,$34,$56,$78,$90,$AB,$CD,$EF,
                                  $12,$34,$56,$78,$90,$AB,$CD,$EF,
                                  $12,$34,$56,$78,$90,$AB,$CD,$EF,
                                  $12,$34,$56,$78,$90,$AB,$CD,$EF);
implementation

uses
  grdlic;

{$R *.dfm}

{ Tfrm_Example }

constructor Tfrm_Example.Create(AOwner: TComponent);
begin
  inherited;

  edt_Public.Text:=                  ReadParam('CODES', 'public', '519175B7');
  edt_Read.Text:=                    ReadParam('CODES', 'read',   '51917645');
  edt_Write.Text:=                   ReadParam('CODES', 'write',  '51917603');

  FFeature:= TFeatureObject.Create;
  lbl_FeatureCheckResult.Caption:= '';
  lbl_FeatureCheckResult.Font.Color:= clBlack;
end;

destructor Tfrm_Example.Destroy;
begin
  if Assigned(FFeature) then
  begin
    if FFeature.Handle > 255 then
      FFeature.Logout;
    FFeature.Free;
  end;

  inherited;
end;

procedure Tfrm_Example.btn_GrdFeatureCheckClick(Sender: TObject);
begin
  FLastError:= FFeature.FeatureCheck(0, nil);
  SendLog('GrdFeatureCheck. Simple', FLastError);

  FLastError:= FFeature.FeatureCheck(40, @PubKey[0]);
  SendLog('GrdFeatureCheck. With Public Key', FLastError);
  if FLastError = GRD_INVALID_PUBLIC_KEY then
  begin
    lbl_FeatureCheckResult.Caption:= '     PubKey';
    lbl_FeatureCheckResult.Font.Color:= clRed;
  end;
end;

procedure Tfrm_Example.btn_GrdFeatureDecryptClick(Sender: TObject);
begin
  FLastError:=  FFeature.Decrypt(@EncDecBuf[0], length(EncDecBuf));
  SendLog('GrdFeatureDecrypt', FLastError);
  if FLastError = Grd_OK then
    edt_EncDecBuffer.Text:=  ArrayToStr(EncDecBuf);
end;

procedure Tfrm_Example.btn_GrdFeatureEncryptClick(Sender: TObject);
var
  i: Integer;
begin
  for i:= Low(EncDecBuf) to High(EncDecBuf) do EncDecBuf[i]:= Buffer[i];

  FLastError:= FFeature.Encrypt(@EncDecBuf[0], length(EncDecBuf));
  SendLog('GrdFeatureEncrypt', FLastError);
  if FLastError = Grd_OK then
    edt_EncBuffer.Text:=  ArrayToStr(EncDecBuf);
end;

procedure Tfrm_Example.btn_GrdFeatureGetMaxConcurrentResourceClick(Sender:
    TObject);
var
  Data: Cardinal;
begin
  Data:= 0;
  FLastError:=  FFeature.GetMaxConcurrentResource(Data);
  SendLog('GrdFeatureGetMaxConcurrentResource', FLastError);
  if FLastError = GRD_OK then
  begin
    edt_MaxConcRes.Text:= UintToStr(Data);
  end;
end;

procedure Tfrm_Example.btn_GrdFeatureGetRunCounterClick(Sender: TObject);
var
  Data: Cardinal;
begin
  Data:= 0;
  FLastError:=  FFeature.GetRunCounter(Data);
  SendLog('GrdFeatureGetRunCounter', FLastError);
  if FLastError = GRD_OK then
  begin
    edt_RunCounterData.Text:= UintToStr(Data);
  end;
end;

procedure Tfrm_Example.btn_GrdFeatureGetTimeLimitClick(Sender: TObject);
var
  DongleTime: TGrdTime;
  s: string;
begin
  FLastError:=  FFeature.GetTimeLimit(DongleTime);
  SendLog('GrdFeatureGetTimeLimit', FLastError);
  if FLastError = GRD_OK then
  begin
    s:= Format('%d  %d  %d ', [DongleTime.wYear, DongleTime.wMonth, DongleTime.wDay]);
    edt_TimeLimit.Text:= s;
  end;
end;

procedure Tfrm_Example.btn_GrdGetApiVersionClick(Sender: TObject);
var
  MajorVersion, MinorVersion: Cardinal;
begin

  MajorVersion:= 0;
  MinorVersion:= 0;
  FLastError:= FFeature.GetApiVersion(MajorVersion, MinorVersion);
  SendLog('GrdGetApiVersion', FLastError);
  edt_MajorVersion.Text:=  UIntToStr(MajorVersion);
  edt_MinorVersion.Text:=  UIntToStr(MinorVersion);
end;

procedure Tfrm_Example.btn_GrdGetLicenseInfoClick(Sender: TObject);
var
  FeatureInfo: TLicense;
  s: string;
begin
  FLastError:= FFeature.GetInfo(FeatureInfo);
  SendLog('GrdFeatureGetInfo', FLastError);
  if FLastError = GRD_OK then
  begin
    s:= Format('%s : %8x', ['license.licenseId', FeatureInfo.licenseInfo.licenseId]) + char(10)+char(13);
    s:= s  + Format('%s : %d', ['product.number', FeatureInfo.licenseInfo.products[0].number]) + char(10)+char(13);
    s:= s  + Format('%s : %d', ['feature.number', FeatureInfo.licenseInfo.products[0].features[0].number]) + char(10)+char(13);
    Application.MessageBox(PWideChar(s), 'GrdFeatureGetInfo', MB_OK + MB_ICONINFORMATION + MB_DEFBUTTON2);
  end;
end;

procedure Tfrm_Example.btn_GrdFeatureLoginClick(Sender: TObject);
var
  RemoteMode: Integer;
begin
  if FFeature.Handle > 255 then
    Exit;

  FVisibility.licenseId:= StrToUint('$' + edt_LicenseId.Text);

  RemoteMode:= 0;
  if cb_LocalMode.Checked then
    RemoteMode:= RemoteMode + Integer(rmLocal);
  if cb_RemoteMode.Checked then
    RemoteMode:= RemoteMode + Integer(rmRemote);
  FVisibility.remoteMode:= TRemoteMode(RemoteMode);

  FVisibility.BroadcastSearch:= true;
  FVisibility.HostName:= AnsiString(edt_HostName.Text);
  if FVisibility.HostName <> '' then
    FVisibility.BroadcastSearch:= false;

  FVisibility.dongleModel:= dmAll;
  FVisibility.productNumber:= StrToInt(edt_ProductId.Text);
  FVisibility.NetworkResourceToConsume:= 1;

  FCodes.PublicCode:=       StrToUInt('$'+edt_Public.Text);
  FCodes.PrivateReadCode:=  StrToUInt('$'+edt_Read.Text);
  FCodes.PrivateWriteCode:= StrToUInt('$'+edt_Write.Text);

  FFeature.Visibility:= FVisibility;

  FFeature.Codes:= FCodes;
  FFeature.FeatureID:= StrToInt(edt_FeatureId.Text);

  FLastError:= FFeature.Login;
  SendLog('GrdFeatureLogin', FLastError);
  if FLastError = Grd_OK then
    edt_Handle.Text:= IntToStr(FFeature.Handle);

end;

procedure Tfrm_Example.btn_GrdFeatureLogoutClick(Sender: TObject);
begin
  if FFeature.Handle < 256 then
    Exit;

  FLastError:= FFeature.Logout();
  SendLog('GrdFeatureLogout', FLastError);

  edt_EncBuffer.Text:= '';
  edt_EncDecBuffer.Text:= '';
  lbl_FeatureCheckResult.Caption:= '';
  lbl_FeatureCheckResult.Font.Color:= clBlack;
  edt_ReadData.Text:= '';
  edt_WriteData.Text:= '';
  edt_RunCounterData.Text:= '';
end;

procedure Tfrm_Example.btn_GrdFeatureSignClick(Sender: TObject);
var
  i: Integer;
begin
  for i:= Low(SignBuf) to High(SignBuf) do SignBuf[i]:= Buffer[i];
  FLastError:=  FFeature.Sign(@SignBuf[0], length(SignBuf), @SignResult[0], Length(SignResult));
  SendLog('GrdFeatureSign', FLastError);
end;

procedure Tfrm_Example.btn_GrdGetRealTimeClick(Sender: TObject);
  var
  DongleTime: TGrdTime;
  s: string;
begin
  FLastError:=  FFeature.GetRealTime(DongleTime);
  SendLog('GrdGetRealTime', FLastError);
  if FLastError = GRD_OK then
  begin
    s:= Format('%4d.%2.2d.%2.2d %2.2d:%2.2d:%2.2d', [DongleTime.wYear, DongleTime.wMonth, DongleTime.wDay, DongleTime.wHour, DongleTime.wMinute, DongleTime.wSecond]);
    edt_DongleTime.Text:= s;
  end;
end;

procedure Tfrm_Example.btn_GrdLedBlinkClick(Sender: TObject);
begin
  FLastError:= GrdLedBlink(StrToUint('$' + edt_LicenseId.Text));
  SendLog('GrdLedBlink', FLastError);
end;

procedure Tfrm_Example.btn_GrdMemoryGetSizeClick(Sender: TObject);
var
  MemId, MemSize: Cardinal;
begin
  MemId:= StrToUint(edt_MemId.Text);
  MemSize:= 0;

  FLastError:=  FFeature.GetMemorySize(MemId, MemSize);
  SendLog('GrdMemoryGetSize', FLastError);
  if FLastError = Grd_OK then
    edt_MemSize.Text:= IntToStr(MemSize);
end;

procedure Tfrm_Example.btn_GrdMemoryReadClick(Sender: TObject);
var
  MemId: Cardinal;
  Passw: Cardinal;
  DataSize, Offset: Cardinal;
begin
  MemId:= StrToUint(edt_MemId.Text);
  Passw:= StrToUint(edt_ReadPass.Text);
  DataSize:= StrToInt(edt_DataSize.Text);
  Offset:= StrToInt(edt_Offset.Text);

  FLastError:= FFeature.MemoryRead(MemId, Passw, DataSize, Offset, @ResBuffer[0]);
  SendLog('GrdMemoryRead', FLastError);
  if FLastError = Grd_OK then
  begin
    edt_ReadData.Text:= ArrayToStr(ResBuffer) ;
  end;
end;

procedure Tfrm_Example.btn_GrdMemoryWriteClick(Sender: TObject);
var
  i: Integer;
  MemId: Cardinal;
  Passw: Cardinal;
  DataSize, Offset: Cardinal;
begin
  MemId:= StrToUint(edt_MemId.Text);
  Passw:= StrToUint(edt_WritePass.Text);
  DataSize:= StrToInt(edt_DataSize.Text);
  Offset:= StrToInt(edt_Offset.Text);

  FLastError:= FFeature.MemoryWrite(MemId, Passw, GRD_WRITE_MODE_MOV, DataSize, Offset, @Buffer[16]);
  SendLog('GrdMemoryWrite', FLastError);
  if FLastError = GRD_OK then
  begin
    for i:= 0 to 15 do
      ResBuffer[i]:= Buffer[i + 16];

    edt_WriteData.Text:= ArrayToStr(ResBuffer);
  end;
end;

procedure Tfrm_Example.btn_GrdVerifyDigestClick(Sender: TObject);
begin
  FLastError:=  FFeature.VerifyDigest(@PubKey[0], Length(PubKey), @SignBuf[0], length(SignBuf), @SignResult[0], Length(SignResult));
  SendLog('GrdFeatureVerifySign', FLastError);
  if FLastError = GRD_INVALID_PUBLIC_KEY then
  begin
    lbl_FeatureCheckResult.Caption:= '     PubKey';
    lbl_FeatureCheckResult.Font.Color:= clRed;
  end;
end;

end.
