unit fruParams;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, fruBaseFrame;

type
  Tfrm_Params = class(TBaseFrame)
    lbl_ActivatioHostAddress: TLabel;
    edt_ActivationServerAddress: TEdit;
    edt_ActivationServerPort: TEdit;
    lbl_Public: TLabel;
    lbl_Read: TLabel;
    lbl_Write: TLabel;
    edt_Public: TEdit;
    edt_Read: TEdit;
    edt_Write: TEdit;
    grp_VendorCodes: TGroupBox;
    grp_Params: TGroupBox;
    lbl_Port: TLabel;
    grp_ActivationServer: TGroupBox;
    procedure edt_ActivationServerAddressChange(Sender: TObject);
    procedure edt_ActivationServerPortChange(Sender: TObject);
    procedure edt_PublicChange(Sender: TObject);
    procedure edt_ReadChange(Sender: TObject);
    procedure edt_WriteChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  end;

implementation

uses
  uHelper;

{$R *.dfm}

constructor Tfrm_Params.Create(AOwner: TComponent);
begin
  inherited;
  edt_ActivationServerAddress.Text:= ReadParam('SERVER', 'host',  'getlicense.guardant.ru');
  edt_ActivationServerPort.Text:=    ReadParam('SERVER', 'port',  '443');
  edt_Public.Text:=                  ReadParam('CODES', 'public', '519175B7');
  edt_Read.Text:=                    ReadParam('CODES', 'read',   '51917645');
  edt_Write.Text:=                   ReadParam('CODES', 'write',  '51917603');
  Self.Description:= '.';
end;

procedure Tfrm_Params.edt_ActivationServerAddressChange(Sender: TObject);
begin
  WriteParam('SERVER', 'host', edt_ActivationServerAddress.Text);
end;

procedure Tfrm_Params.edt_ActivationServerPortChange(Sender: TObject);
begin
  WriteParam('SERVER', 'port', edt_ActivationServerPort.Text);
end;

procedure Tfrm_Params.edt_PublicChange(Sender: TObject);
begin
  WriteParam('CODES', 'public', edt_Public.Text);
end;

procedure Tfrm_Params.edt_ReadChange(Sender: TObject);
begin
  WriteParam('CODES', 'read', edt_Read.Text);
end;

procedure Tfrm_Params.edt_WriteChange(Sender: TObject);
begin
  WriteParam('CODES', 'write', edt_Write.Text);
end;

end.
